#include <SoftwareSerial.h>

#include <FastLED.h>
#define NUM_LEDS  15
CRGBPalette16 currentPalette;
#define LED_PIN1   3
#define LED_PIN2   5
#define LED_PIN3   6
#define LED_PIN4   9
#define LED_PIN5   10
#define LED_PIN6   11

SoftwareSerial ArduinoSlave(12,13);
char cmd="";
char old_cmd;
char answer="";
char old_answer;

const int  buttonPin1 = 0; 
int buttonState1 = 1;  
const int  buttonPin2 = 1; 
int buttonState2 = 1;  
const int  buttonPin3 = 2; 
int buttonState3 = 1;  
const int  buttonPin4 = 4; 
int buttonState4 = 1;  
const int  buttonPin5 = 7; 
int buttonState5 = 1;  
const int  buttonPin6 = 8; 
int buttonState6 = 1;  



CRGB leds1[NUM_LEDS];
CRGB leds2[NUM_LEDS];
CRGB leds3[NUM_LEDS];
CRGB leds4[NUM_LEDS];
CRGB leds5[NUM_LEDS];
CRGB leds6[NUM_LEDS];


uint8_t paletteIndex = 0;

CRGBPalette16 purplePalette = CRGBPalette16 (
    CRGB::DarkViolet,
    CRGB::DarkViolet,
    CRGB::DarkViolet,
    CRGB::DarkViolet,
    
    CRGB::Magenta,
    CRGB::Magenta,
    CRGB::Linen,
    CRGB::Linen,
    
    CRGB::Magenta,
    CRGB::Magenta,
    CRGB::DarkViolet,
    CRGB::DarkViolet,

    CRGB::DarkViolet,
    CRGB::DarkViolet,
    CRGB::Linen,
    CRGB::Linen
);


CRGBPalette16 blackPalette = CRGBPalette16 (
    CRGB::Black,
    CRGB::Black,
    CRGB::Black,
    CRGB::Black
);

void setup() {
  ArduinoSlave.begin(9600); 

 pinMode(buttonPin1, INPUT_PULLUP);
 pinMode(buttonPin2, INPUT_PULLUP);
 pinMode(buttonPin3, INPUT_PULLUP);
 pinMode(buttonPin4, INPUT_PULLUP);
 pinMode(buttonPin5, INPUT_PULLUP);
 pinMode(buttonPin6, INPUT_PULLUP);

  FastLED.addLeds<WS2812B, LED_PIN1, GRB>(leds1, NUM_LEDS);
  FastLED.addLeds<WS2812B, LED_PIN2, GRB>(leds2, NUM_LEDS);
  FastLED.addLeds<WS2812B, LED_PIN3, GRB>(leds3, NUM_LEDS);
  FastLED.addLeds<WS2812B, LED_PIN4, GRB>(leds4, NUM_LEDS);
  FastLED.addLeds<WS2812B, LED_PIN5, GRB>(leds5, NUM_LEDS);
  FastLED.addLeds<WS2812B, LED_PIN6, GRB>(leds6, NUM_LEDS);
  FastLED.setBrightness(50);
}

void loop() {

  if (digitalRead(buttonPin1) == 0 )
  {
buttonState1 = 0;
  }
   if (digitalRead(buttonPin2) == 0 )
  {
buttonState2 = 0;
  }
   if (digitalRead(buttonPin3) == 0 )
  {
buttonState3 = 0;
  }
   if (digitalRead(buttonPin4) == 0 )
  {
buttonState4 = 0;
  }
   if (digitalRead(buttonPin5) == 0 )
  {
buttonState5 = 0;
  }
   if (digitalRead(buttonPin6) == 0 )
  {
buttonState6 = 0;
  }

 old_cmd=cmd;
 old_answer=answer;
  //Read command from monitor
  if (Serial.available()){
    cmd=Serial.read();
  } 
  //Read answer from slave
  if (ArduinoSlave.available()){
    answer=ArduinoSlave.read();
  } 
  //Send data to slave
  if(cmd!=old_cmd){
    Serial.print("Master sent : ");
    Serial.println(cmd);
    ArduinoSlave.write(cmd);
    delay(10);
  }
  //Send answer to monitor
  if(answer!=old_answer){
    Serial.print("Slave received : ");
    Serial.println(answer);
  }



if ( buttonState1 == 0)
{
fill_palette(leds1, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, purplePalette, 255, LINEARBLEND);
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  FastLED.show();
}
if ( buttonState2 == 0)
{
fill_palette(leds2, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, purplePalette, 255, LINEARBLEND);
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  FastLED.show();
}
if ( buttonState3 == 0)
{
fill_palette(leds3, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, purplePalette, 255, LINEARBLEND);
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  FastLED.show();
}
if ( buttonState4 == 0)
{
fill_palette(leds4, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, purplePalette, 255, LINEARBLEND);
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  FastLED.show();
}
if ( buttonState5 == 0)
{
fill_palette(leds5, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, purplePalette, 255, LINEARBLEND);
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  FastLED.show();
}
if ( buttonState6 == 0)
{
fill_palette(leds6, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, purplePalette, 255, LINEARBLEND);
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  FastLED.show();
}


if (buttonState1 == 0 && buttonState2 == 0 && buttonState3 == 0 && buttonState4 == 0 && buttonState5 == 0 && buttonState6== 0 )

  {
    ArduinoSlave.write("F");
  }

  
if (cmd == 'O' || answer == 'O' )
{
fill_palette(leds5, NUM_LEDS, paletteIndex, 255 / NUM_LEDS, blackPalette, 255, LINEARBLEND);
  
  EVERY_N_MILLISECONDS(10){
    paletteIndex++;
  }
  
  FastLED.show();
}
 
}
